#ifndef __TEXTURE1D_H__
#define __TEXTURE1D_H__

#include "texture.h"

namespace moglclass
{

class Texture1D : public Texture
{
public:
    Texture1D(char *filename=0, GLint wrap=GL_REPEAT, GLint min=GL_LINEAR, GLint mag=GL_LINEAR);
    virtual ~Texture1D(void);
    virtual void bind(void);
    virtual void disable(void);
    void load(void);
	bool isLoaded() { return loaded; }
	unsigned int getTextureID() { return uiTexture; }

	void setSamplerParameter(GLenum parameter, GLenum value);
	unsigned int getSamplerID(void) { return uiSampler; }

private:
    unsigned char * imageData;
    unsigned char * rescaledImageData;
    int width, height, numComponents;
	GLenum type;

	bool loaded;
    bool createdImage;

	GLuint uiTexture;
	GLuint uiSampler;
};

} // namespace

#endif
